/*
 * "ArduinomeFirmware" - Arduino Based Monome Clone by Owen Vallis & Jordan Hochenbaum 06/16/2008
 * Revised 06/26/2008
 * Revised 07/20/2008 by Ben Southall
 *
 * --------------------------------------------------------------------------
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * --------------------------------------------------------------------------
 *
 * This code is largely a direct translation of the 40h protocol designed by Brian Crabtree
 * & Joe Lake, and coded by Joe Lake.  We would like to express our utmost thanks for making
 * the monome & its inner-workings available and open source.  We would also like to extend
 * our thanks to all those who have helped us get this far in successfully making an arduino-
 * based monome clone, including but not limited to Brad Hill for his awesome arduino shield, 
 * and Melka for showing how to pack and unpack the serial data.
 *
 * Additional comment and attribution 7/20/2008 : 
 * The changes on 7/20/2008 were inspired by, and at least in some part, directly
 * copied from the 'Octinct' code written by Jonathan M Guberman (upwardnotnorthward.com).  
 * In particular, the use of timer 2 to drive an interrupt routine to read the serial port was
 * picked up from the Octinct project, and also, setting the baud rate to 57600 seemed to be 
 * critical for getting everything to work reliably.  My thanks to Jonathan for sharing his
 * software, and for figuring out how to keep that serial buffer in check.
 *
 * Please DO NOT email monome with technical questions and/or help regarding this code or clone.  
 * They are in NO WAY responsible or affiliated with this project other than they were our inspiration 
 * and we used many of their methods and pulled from their code.
 * 
 * Additionally, while we are availble and willing to help as much as possible, we too CANNOT be held
 * responsible for anything you do with this code.  Please feel free to report any bugs, suggestions 
 * or improvements to us as they are all welcome.  Again, we cannot be held responsible for any damages 
 * or harm caused by the use or misuse of this code or our instructions.  Thank you for understanding.
 * --------------------------------------------------------------------------
 *
 * Links:
 * http://bricktable.wordpress.com - Our website - Click "Arduino Monome Project" on the Navigation Menu on the right.
 * www.monome.org - the "original" monome and our inspiration
 * www.flickr.com/photos/unsped/2283428540/in/photostream/
 * http://play-collective.net/blog/archives/category/arduinomonomergb
 *
 */



/*
Ok, so I'm gonna but a few defines in here
 
 */

//these are to set the serial protocol driver speed

#define OSX 1
#define WIN 0
#define LINUX 0


/* Here is where you choose which display driver to use*/

#define DISPLAY_DRIVER_UNSPED 0
#define DISPLAY_DRIVER_LARSBY 1
#define DISPLAY_DRIVER_EMPTY 0

/* Here is where you choose which display driver to use */

#define BUTTON_DRIVER_UNSPED 0
#define BUTTON_DRIVER_LARSBY 1
#define BUTTON_DRIVER_EMPTY 0




//------------------------------------------------------------------------------------------
// Button typedefs

byte button_current[8];
byte button_last[8];
byte button_state[8];
byte button_event[8];

void init_buttons_driver();

//function to read the state and populate the button array's
void populate_buttons();


//------------------------------------------------------------------------------------------
// Display typedefs
byte ledmem[8];                         // memory for LEDs

//function to display pretty patterns on screen to show that the arduino is inited properrly
void displayWhoosh();

//initiates variables and such
void displayInit();


//changes the intensity of the screen
void ChangeIntensity(int inval);

//init's a display test function
void ChangeDisplayTest(byte inval);

//sets the sceen into shutdownmode 
void ShutdownMode(byte inval);

//main loop update thingy
void updateLED();
//utility function to wipe the screen
void clearAllLights();






/* changing to defines where approperiate made size go from 4712 to 4350 bytes with unsped drivers *//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
