
#if BUTTON_DRIVER_UNSPED

//164 (from serial to IC)               // set which pins to use
// load data from computer to 164
#define dataPin  3
// pulse to load bits (one bit for each clock pulse)
#define clockPin  2

//165 (from IC to serial)
// toggling this tells the 165 to read the byte into its memory for reading
#define inloadPin   8                     
// pull the data out of the 165 bit by bit 
#define indataPin   9                     
// pulse to pull bits (one bit for each clock pulse)
#define inclockPin   7                     

byte t = 0;
int id = 0;

//164 (from serial to IC)               // set which pins to use
//  dataPin = 3 = PORTD, bit 3
// clockPin = 2 = PORTD, bit 2
#define dataPinMaskHigh  (1 << 3)
#define dataPinMaskLow   (~dataPinMaskHigh)


#define clockPinMaskHigh ( 1 << 2)
#define clockPinMaskLow (~clockPinMaskHigh)

//165 (from IC to serial)
//  inloadPin = 8 = PORTB, bit 0
// indataPin = 9 = PORTB, bit 1
// inclockPin = 7 = PORTD, bit 7
#define inloadPinMaskHigh  1
#define inloadPinMaskLow ( ~inloadPinMaskHigh)


#define indataPinMask (1 << 1)

#define inclockPinMaskHigh  (1 << 7)
#define inclockPinMaskLow  (~inclockPinMaskHigh)


/* this function populates the buffers with the current state of the buttons */

void populate_buttons () {


  int i = 0;

  PORTD &= dataPinMaskLow; // digitalWrite(dataPin, LOW);
  //164
  for(i = 0; i < 8; i++){
    PORTD |= clockPinMaskHigh; // digitalWrite(clockPin, HIGH);
    PORTD &= clockPinMaskLow;  //digitalWrite(clockPin, LOW);
    PORTD |= dataPinMaskHigh;  //digitalWrite(dataPin, HIGH);

    volatile int a = 0; 

    while (a < 15) 
    { 
      a++; 
    } 

    button_last [i] = button_current [i]; 

    //165
    PORTB &= inloadPinMaskLow; // digitalWrite(inloadPin, LOW);
    PORTB |= inloadPinMaskHigh;// digitalWrite(inloadPin, HIGH);

    for(id = 0; id < 8; id++) {

      t = (PINB & indataPinMask) >> 1;//t = digitalRead(indataPin);
      t = (t == 0);
      if(t){
        button_current [i] |= (1 << id);
      }
      else{
        button_current [i] &= ~(1 << id);
      }

      PORTD |= inclockPinMaskHigh; // digitalWrite(inclockPin, HIGH);
      PORTD &= inclockPinMaskLow;  // digitalWrite(inclockPin, LOW);
    }
  } 

}

void init_buttons_driver()
{

}


#endif
