#if BUTTON_DRIVER_LARSBY


#define pin_button_data  10
#define pin_button_clock  9
#define pin_button_apl  8

#define pin_button_latch  pin_button_apl

void init_buttons_driver()
{
  pinMode(pin_button_latch, OUTPUT);
  pinMode(pin_button_clock, OUTPUT); 
  pinMode(pin_button_data, INPUT);
}

void toggleAllButtons() //will swap all the bytes, the hardware I use gives 1 as default
{

   for (int I = 0; I < 8; I++)
   for (int y  = 0; y < 8; y++)
      button_current[I]  ^= (1 << (7-y));
}


//function to read the state and populate the button array's
void populate_buttons () {
  
    for (int i = 0; i < 8; i++)
      button_last [i] = button_current [i]; 


   pulse_pin(pin_button_latch); // sample the button states

 for (int I = 0; I < 8; I++)
  button_current[I]= get_button_states();
  toggleAllButtons();
}


byte get_button_states(){
  byte my_bit;
  byte button_byte;

  button_byte=0; // clear the byte ready for new data
  for (int n=0; n<8; n++){
    button_byte = button_byte << 1 ; // shift bits to the left, making space to capture the state of the next button
    button_byte=clear_lsb(button_byte); // make sure the new lsb is zero, to avoid surprises
    my_bit = digitalRead(pin_button_data); // store the current Q7 value from the button register in my_bit 
    button_byte = button_byte | my_bit; // OR th my_input with the new bit to add it to the lsb 
    pulse_pin(pin_button_clock); // cue the next bit slot for reading
  }
  return(button_byte);
}


// Set a pin to low, then high
void pulse_pin(int pin_number){
  digitalWrite(pin_number,LOW);
  //delayMicroseconds(20);
  digitalWrite(pin_number,HIGH);
}

// Clear the least significant bit
byte clear_lsb(byte byte_to_clear){
  return(byte_to_clear & 0xfe);  // AND the byte with 11111110 to be sure that the LSB is zero
}

 

#endif
