#define kButtonUpDefaultDebounceCount    12
#define kButtonNewEvent    1
#define kButtonNoEvent     0

byte button_debounce_count[8][8];




void buttonInit(void){
  byte i;
  for (i = 0; i < 8; i++) {
    button_current[i] = 0x00;
    button_last[i] = 0x00;
    button_state[i] = 0x00;
    button_event[i] = 0x00;
  }

  init_buttons_driver();
}


void buttonCheck(byte row, byte index)
{
  if (((button_current[row] ^ button_last[row]) & (1 << index)) &&   // if the current physical button state is different from the
  ((button_current[row] ^ button_state[row]) & (1 << index))) {  // last physical button state AND the current debounced state

    if (button_current[row] & (1 << index)) {                      // if the current physical button state is depressed
      button_event[row] = kButtonNewEvent << index;              // queue up a new button event immediately
      button_state[row] |= (1 << index);                         // and set the debounced state to down.
    }
    else{
      button_debounce_count[row][index] = kButtonUpDefaultDebounceCount;
    }  // otherwise the button was previously depressed and now
    // has been released so we set our debounce counter.
  }
  else if (((button_current[row] ^ button_last[row]) & (1 << index)) == 0 &&  // if the current physical button state is the same as
  (button_current[row] ^ button_state[row]) & (1 << index)) {        // the last physical button state but the current physical
    // button state is different from the current debounce 
    // state...

    if (button_debounce_count[row][index] > 0 && --button_debounce_count[row][index] == 0) {  // if the the debounce counter has
      // been decremented to 0 (meaning the
      // the button has been up for 
      // kButtonUpDefaultDebounceCount 
      // iterations///

      button_event[row] = kButtonNewEvent << index;    // queue up a button state change event

      if (button_current[row] & (1 << index)){          // and toggle the buttons debounce state.
        button_state[row] |= (1 << index);
      }
      else{
        button_state[row] &= ~(1 << index);
      }
    }
  }
}



void check_and_send_buttons(void)
{
  int b = 0;

  for(int i = 0; i < 8; i++)
  {

    for(int id = 0; id < 8; id++) 
    {

      buttonCheck(i, id);

      if (button_event[i] & (1 << id)) 
      {
        button_event[i] &= ~(1 << id);
        if(button_state[i] & (1 << id))
        {
          b = 1;
        }
        else
        {
          b = 0;
        }
      //  toggleLed(7,0); den hr fungerar ju!
        Serial.print((0 << 4) | (b & 15), BYTE);
        Serial.print((id << 4) | (i & 15), BYTE);
 //       Serial.print((0 << 4) | (b & 15), DEC);
   //     Serial.print(" ");
     //   Serial.println((id << 4) | (i & 15), DEC);
      }
    }
  }
}

